#!/usr/bin/perl
#--NetShopOwner-CGI-version:4.2.5.5--

;#
;# goods_search.cgi
;# [PC]iʉ
;# Copyright (c) 2004- Increment P Corp. All rights reserved.
;#
;# 2009/09/30 NSO4Ή
;# last modified 2010/06/30 DVC3Ή
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use NsoPage;
use NsoSearch;
use Design::NsoPagingBar;
use Lib::SiteStatus;
use Design::NsoSearchTable;
use Lib::DbConnect;
use DB::NsoGoodsVariationDB;
use DB::NsoStockDB;
# 20100630 Y.Motai start
use DB::NsoDetailUrl;
# 20100630 Y.Motai end


&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $NsoMisc         = NsoMisc->new();
my $NsoPage        = NsoPage->new();
my $NsoSearch      = NsoSearch->new();
# 20100630 Y.Motai start
my $DetailUrl       = NsoDetailUrl->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});
# 20100630 Y.Motai end

my $DbConnect = Lib::DbConnect->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});

my $GoodsVariationDB = NsoGoodsVariationDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});
my $NsoStockDB       = NsoStockDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });

my $status_err;
my $category_name;

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
	);
	
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}
exit();

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing({ IgnoreFlag=>1 });
}

;#
;# C
;#
sub main {
	# iDB擾
	my %GdsDB = &get_goods_db();
	
	# ev[gu
	&replace_tmpl(\%GdsDB);
	
}

;# iDBt@X擾
;#
sub get_goods_db {
	# JeSID
	my $CategoryID = $in{CategoryID};

	# L[[h
	my %HashKeyword  = $NsoSearch->analyze_keyword($in{Keyword}, 'sjis');
	my %HashPriceMin = $NsoSearch->analyze_keyword($in{PriceMin}, 'sjis');
	my %HashPriceMax = $NsoSearch->analyze_keyword($in{PriceMax}, 'sjis');
	
	my @Keywords = @{$HashKeyword{keywords}};
	my $PriceMin = $in{PriceMin};
	my $PriceMax = $in{PriceMax};

	if ( $PriceMin =~ m/[^0-9OPQRSTUVWX]/ig || $PriceMax =~ m/[^0-9OPQRSTUVWX]/g){
		$status_err = $status_err . "<br>" . "iݒɕs܂B" if($status_err ne "");
		$status_err = "iݒɕs܂B" if($status_err eq "");
		$PriceMin = "";
		$PriceMax = "";
	}
	# Sp𔼊pɒ
	$PriceMin = $NsoMisc->e_zenshan($PriceMin);
	$PriceMax = $NsoMisc->e_zenshan($PriceMax);
	
	# L[[h
	my $Keycnt = @Keywords;
	if ( ($ConfigSystem{SearchList}{pc}{KeyCount}) and $ConfigSystem{SearchList}{pc}{KeyCount} < $Keycnt ) {
		$status_err = $status_err . "<br>" . "L[[h܂B" if($status_err ne "");
		$status_err = $status_err . "L[[h܂B" if($status_err eq "");
		return ( RecordCount => 0 );
		return;
	}
	
	# iݒAL[[hSĂ̖͂̏ꍇɂ͌0Ƃ
	if ( $PriceMin eq "" && $PriceMax eq "" && $Keycnt eq 0){
		return ( RecordCount => 0 );
	}

	# DBڑ
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		$status_err = $status_err . "<br>" . $connectError if($status_err ne "");
		$status_err = $status_err . $connectError if($status_err eq "");
		return ( RecordCount => 0 );
	}

	# L[[h̃GXP[v`
	my $i = 0; 
	foreach my $str (@Keywords){
		# L[[h͎ɂłsjisɃfR[hĂ̂ŁAsjiseucfR[h
		$str = $NsoMisc->j_decode_sjis2euc($str);
		# \͂ꂽꍇAGXP[v(\\)
		$str =~ s/\\/\\\\/g;
		# łeucɃfR[hĂ̂ŁAfR[hȂGXP[v
		$str = $DbConnect->Sql_Escape_non_decode($str);
		# LIKẼChJ[hGXP[v
		$str =~ s/\%/\\\%/g;
		$str =~ s/\_/\\\_/g;
		# LIKEŎgp邽ߑOɃChJ[ht
		$str =~ s/^'/'%/g;
		$str =~ s/'$/%'/g;
		$Keywords[$i] = $str;
		$i++;
	}
	
	# NG쐬
	my $SQL_query = $NsoSearch->make_searchQuery({ keywords=>\@Keywords, priceMin=>$PriceMin, priceMax=>$PriceMax, target=>0} );

	# NGs
	my %db = $DbConnect->DbSelect($SQL_query);
	
	# SQL ʎ擾
	my $RecordList = %db->{RecordList};
	my $queryError = %db->{status_err};
	if ( $queryError ne "" ){
		$status_err = $status_err . "<br>" . $queryError if($status_err ne "");
		$status_err = $status_err . $queryError if($status_err eq "");
		return ( RecordCount => 0 );
	}
	my $RecordCount = scalar @$RecordList;

	my $StartLine   = 0;
	my $EndLine     = $RecordCount;

	return (
		RecordList  => $RecordList,
		RecordCount => $RecordCount,
	);
}

;#
;# y[WO擾
;#
sub get_paging_info {
	my ($db) = @_;
	my $RecordCount = $db->{RecordCount};
	
	my $CategoryID = $in{CategoryID};
	my $pn = ($in{pn} eq "" ? 0 : $in{pn});
	my $sl = $ConfigSystem{SearchList}{pc}{SplitLine} || 20;
	my %query_hash = (
		Keyword    => $NsoMisc->html_encode($in{Keyword}),
		PriceMin   => $NsoMisc->html_encode($in{PriceMin}),
		PriceMax   => $NsoMisc->html_encode($in{PriceMax}),
	);
	
	# CGIURL
	my $GoodsSearchURL = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{goods_search};
	# SSL󋵂ɉURLu
	$GoodsSearchURL = $NsoMisc->getChangedURL({url=>$GoodsSearchURL, key=>'OtherCgi'});
	
	my %paging_args = (
		sum    => $RecordCount,
		pn     => $pn,
		sl     => $sl,
		action => $GoodsSearchURL,
		method => "get",
		query  => \%query_hash,
	);
	return $NsoPage->make_page_button(\%paging_args);
}

;#
;# y[WOo[擾
;#
sub get_paging_bar {
	my ($db) = @_;
	my %paging = &get_paging_info($db);
	
	my $NsoPagingBar = Design::NsoPagingBar->new({ ConfigSystem=>\%ConfigSystem });
	return (
		PagingBarUpper => $NsoPagingBar->GetPagingBar({ paging=>\%paging, key=>'GoodsSearch', kind=>'PagingBarUpper' }),
		PagingBarLower => $NsoPagingBar->GetPagingBar({ paging=>\%paging, key=>'GoodsSearch', kind=>'PagingBarLower' }),
	);
}

;#
;# ev[gu
;#
sub replace_tmpl {
	my ($db) = @_;
	my %paging = &get_paging_bar($db);
	my $RecordList  = $db->{RecordList};
	my $RecordCount = $db->{RecordCount};
	my $pn = ($in{pn} eq "" ? 0 : $in{pn});
	my $sl = $ConfigSystem{SearchList}{pc}{SplitLine} || 20;

	my $NsoSearchTable = Design::NsoSearchTable->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});

	my $system_templ_dir   = $main::nsoDB_path ."/";
	my $system_templ_kind  = "templ";
	my $system_templ_head  = "goods_search_head.htmp";
	my $system_templ_body1 = "goods_search_body1.htmp";
	my $system_templ_body2 = "goods_search_body2.htmp";
	my $system_templ_foot  = "goods_search_foot.htmp";
	
	my $contents_head;
	my $contents_body1;
	my $contents_body2;
	my $contents_foot;
	my %htmls = ();
	
	$htmls{status_err} = "ʂ͂܂ " if ( $RecordCount == 0 );
	$htmls{status_err} = $status_err if ( $status_err ne "" );
	
	# VXeev[g(wb^)u
	TemplHead:{
		# ev[gu
		my $NsoTempl = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$system_templ_head });
		my %Text = ();
		# ẻʂւ̐ݒ
		$Text{Keyword} = $in{Keyword};
		$Text{PriceMin} = $in{PriceMin};
		$Text{PriceMax} = $in{PriceMax};
		my %replace_templ = ( 
				htmls  => \%htmls ,
				Text   => \%Text
				);
		$contents_head = $NsoTempl->replace_templ(\%replace_templ);
	};

	# VXeev[g(tb^)u
	TemplFoot:{
		# ev[gu
		my $NsoTempl = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$system_templ_foot });
		my %replace_templ = ( paging => \%paging );
		$contents_foot = $NsoTempl->replace_templ(\%replace_templ);
	};
	
	# YiȂꍇ̓wb_Atb^̂ݏo͂I
	if ( $RecordCount == 0 ) {
		print $NsoMisc->print_header();
		print $contents_head.$contents_foot;
		return;
	}
	
	# VXeev[g({fB1)u
	TemplBody1:{
		# ev[gu
		my $NsoTempl = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$system_templ_body1 });
		my %replace_templ = ();
		$contents_body1 = $NsoTempl->replace_templ(\%replace_templ);
	};

	# VXeev[g({fB2)u
	TemplBody2:{
		my $i = -1;
		foreach my $Record (@{$RecordList}){
			$i++;
			# Jnʒu܂Ŕ΂
			next if ( $i < $pn * $sl);
			
			# Iʒu
			last if ( $i > ($pn * $sl) + $sl - 1 );

			my $cnt = 0;
			my %RecordHash = (
				ArticleID             => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 01 iID
				ArticleNo             => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 02 iԍ
				ArticleName           => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 03 i
				ArticleNameMobile     => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 04 gїpi
				ProductTypeName       => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 05 Cӑ
				ProductName           => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 06 Cӑl
				LabeledPriceName      => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 07 CӒ艿
				LabeledPrice          => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 08 艿
				ExTaxPrice            => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 09 ŕʉi
				InTaxPrice            => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 10 ōi
				SalePriceName         => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 11 CӔ
				CarriageType          => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 12 敪
				DeliveryTypeID        => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 13 z^Cv
				ShareRate             => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 14 dݕt
				MaxOrderCount         => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 15 1x̒ōwł鐔
				ShowAdditionalIcon1   => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 16 ACR\tO1
				ShowAdditionalIcon2   => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 17 ACR\tO2
				ShowAdditionalIcon3   => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 18 ACR\tO3
				ShowAdditionalIcon4   => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 19 ACR\tO4
				VariationTypeName1    => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 20 oG[V1ږ
				VariationAvable1      => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 21 oG[V1IK{tO
				VariationTypeName2    => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 22 oG[V2ږ
				VariationAvable2      => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 23 oG[V2IK{tO
				VariationTypeName3    => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 24 oG[V3ږ
				VariationAvable3      => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 25 oG[V3IK{tO
				VariationTypeName4    => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 26 oG[V4ږ
				VariationAvable4      => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 27 oG[V4IK{tO
				KeywordAndDescription => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 28 pL[[hƏЉ
				Show_PC               => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 29 \ݒiPC)
				Show_Mobile           => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 30 \ݒig)
				Point                 => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 31 iʃ|Cg
				SearchShow            => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 32 iΏ
				StockType             => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 33 ݌ɊǗ^Cv
				ExplanationMobile     => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 34 gїp
				ArticleCategoryID     => $NsoMisc->j_decode_euc2sjis($$Record[$cnt++]),  # 35 JeSID
				);

			# ݌ɐ擾AR[hɒǉ
			my $stock = $NsoStockDB->GetStockQuerySum($RecordHash{ArticleID});
			if($stock eq ""){
				# ݌ɐ-1w
				$RecordHash{StockSum} = -1;
			} else {
				$RecordHash{StockSum} = $stock;
			}

			# oG[Vݒ肳Ă鏤ȉꍇAArticleVariatione[u擾
			if ($RecordHash{VariationTypeName1} ne "" ||
			    $RecordHash{VariationTypeName2} ne "" ||
			    $RecordHash{VariationTypeName3} ne "" ||
			    $RecordHash{VariationTypeName4} ne ""){

				my %resultArticleVariation = $GoodsVariationDB->GetArticleVariationAll($RecordHash{ArticleID});
				my %resultArticleVariationHash = (
					RecordList  => $resultArticleVariation{RecordList},
					RecordCount => $resultArticleVariation{RecordCount},
					status_err  => $resultArticleVariation{status_err},
				);

				# DBG[
				if ($resultArticleVariationHash{status_err} ne ""){
					# DBG[ݒ
					$htmls{status_err} = $resultArticleVariationHash{status_err};

					# wb_č쐬
					# ev[gu
					my $NsoTempl = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$system_templ_head });
					my %Text = ();
					# ẻʂւ̐ݒ
					$Text{Keyword} = $in{Keyword};
					$Text{PriceMin} = $in{PriceMin};
					$Text{PriceMax} = $in{PriceMax};
					my %replace_templ = ( 
							htmls  => \%htmls ,
							Text   => \%Text
							);
					$contents_head = $NsoTempl->replace_templ(\%replace_templ);
					
					# wb_Atb^o͂ăG[I
					print $NsoMisc->print_header();
					print $contents_head.$contents_foot;
					return;
				}

				# R[hnbVɂ̏ĩoG[Vzǉ
				$RecordHash{VariationArray} = $resultArticleVariationHash{RecordList};
			}

			# 20100706 Y.Motai start
			# ΏۂƂȂiIDURLf[^nbV擾
			my %UrlData = $DetailUrl->make_GetUrlQuery({ ArticleID => $RecordHash{ArticleID} });

			my %resultUrlDataHash = (
				RecordList  => $UrlData{RecordList},
				RecordCount => $UrlData{RecordCount},
				status_err  => $UrlData{status_err},
			);

			# DBG[
			if ($resultUrlDataHash{status_err} ne ""){
				# DBG[ݒ
				$htmls{status_err} = $resultUrlDataHash{status_err};
			}
			# 20100706 Y.Motai end

			my %InfoHash = $NsoSearchTable->GetInfoByGoods(\%RecordHash);
			my %Tag  = %{$InfoHash{Tag}};
			my %Text = %{$InfoHash{Text}};

			# 20100712 Y.Motai start
			# iڍ׃y[WpURLuΏۂɒǉ
			$Text{URL}    = $resultUrlDataHash{RecordList};
			# 20100712 Y.Motai end

			# ev[gu
			my $NsoTempl = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$system_templ_body2 });
			my %replace_templ = (
				Tag  => \%Tag,
				Text => \%Text,
			);
			
			# 20100701 Y.motai start
			# URLݒ̗LɂTagsߌOɕʕϐɎ擾
			my $contents_body2_sub = $NsoTempl->replace_templ(\%replace_templ);
			
			# URL݂ĂȂTaĝݍ폜AURL݂ĂȂȂTag̒gTag܂߂č폜
			if ( $resultUrlDataHash{RecordList} eq "" ) {
				$contents_body2_sub =~ s/<!--\$\$Tag{ImageUrl_Front_Start}\$\$-->.*<!--\$\$Tag{ImageUrl_Front_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ImageUrl_Back_Start}\$\$-->.*<!--\$\$Tag{ImageUrl_Back_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{NameUrl_Front_Start}\$\$-->.*<!--\$\$Tag{NameUrl_Front_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{NameUrl_Back_Start}\$\$-->.*<!--\$\$Tag{NameUrl_Back_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ButtonUrl_Start}\$\$-->.*<!--\$\$Tag{ButtonUrl_End}\$\$-->//s;
			} else {
				$contents_body2_sub =~ s/<!--\$\$Tag{ImageUrl_Front_Start}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ImageUrl_Front_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ImageUrl_Back_Start}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ImageUrl_Back_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{NameUrl_Front_Start}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{NameUrl_Front_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{NameUrl_Back_Start}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{NameUrl_Back_End}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ButtonUrl_Start}\$\$-->//s;
				$contents_body2_sub =~ s/<!--\$\$Tag{ButtonUrl_End}\$\$-->//s;
			}
			
			# 폜A
			$contents_body2 .= $contents_body2_sub;
			# $contents_body2 .= $NsoTempl->replace_templ(\%replace_templ);
			# 20100701 Y.motai end
		}
	}
	
	print $NsoMisc->print_header();	
	print $contents_head.$contents_body1.$contents_body2.$contents_foot;

}












